Drupal.behaviors.yandexmappage = function(context) {
	var map, geoResult, placemark, placemark_options;
	function mapCommonSet(map){
		// Установка для карты ее центра и масштаба
		if (Drupal.settings.yandex_map.center) {
			map.setCenter(new YMaps.GeoPoint(
					Drupal.settings.yandex_map.center.lng,
					Drupal.settings.yandex_map.center.lat),
					Drupal.settings.yandex_map.center.zoom);
		}
		if (Drupal.settings.yandex_map.mapcontrol_options.TypeControl) {
			map.addControl(new YMaps.TypeControl());
		}
		if (Drupal.settings.yandex_map.mapcontrol_options.ToolBar) {
			map.addControl(new YMaps.ToolBar());
		}
		if (Drupal.settings.yandex_map.mapcontrol_options.Zoom) {
			map.addControl(new YMaps.Zoom());
		}
		if (Drupal.settings.yandex_map.mapcontrol_options.MiniMap) {
			map.addControl(new YMaps.MiniMap(),
					new YMaps.ControlPosition(
							YMaps.ControlPosition.BOTTOM_RIGHT));
		}
		if (Drupal.settings.yandex_map.mapcontrol_options.ScaleLine) {
			map.addControl(new YMaps.ScaleLine(),
					new YMaps.ControlPosition(
							YMaps.ControlPosition.BOTTOM_LEFT));
		}
		if (Drupal.settings.yandex_map.mapcontrol_options.copyright) {
			map.addCopyright(Drupal.settings.yandex_map.copyright);
		}
		if (Drupal.settings.yandex_map.mapcontrol_options.DblClickZoom) {
			map.enableDblClickZoom();
		} else {
			map.disableDblClickZoom();
		}
		if (Drupal.settings.yandex_map.mapcontrol_options.Dragging) {
			map.enableDragging();
		} else {
			map.disableDragging();
		}
		if (Drupal.settings.yandex_map.mapcontrol_options.ScrollZoom) {
			map.enableScrollZoom();
		} else {
			map.disableScrollZoom();
		}
		if (Drupal.settings.yandex_map.mapcontrol_options.HotKeys) {
			map.enableHotKeys();
		} else {
			map.disableHotKeys();
		}
		map.addControl(new YMaps.SearchControl());
	};
	if (Drupal.settings.yandex_map.start) {
		if (Drupal.settings.yandex_map.items) { // exists placemarks
			placemark_options = {
				draggable : Drupal.settings.yandex_map.placemark_options.draggable,
				hasBalloon : Drupal.settings.yandex_map.placemark_options.hasBalloon,
				hintOptions : {
					maxWidth : 150,
					maxHeight : 150
				}
			};
			balloon_options = {
				maxWidth : 150,
				maxHeight : 150,
				hasCloseButton : true,
				mapAutoPan : true
			}
			YMaps.jQuery(function() {
				// Создание экземпляра карты и его привязка к созданному
				// контейнеру
					var map = new YMaps.Map(YMaps.jQuery("#yandex_map_view")[0]);
					mapCommonSet(map);
					// this is not "add" or "edit" page
					if (Drupal.settings.yandex_map.show_options.view) {
						items = Drupal.settings.yandex_map.items;
						items_number = items.length;
						placemarks = new Array();
						var collectionBounds = new YMaps.GeoCollectionBounds();
						for (i = 0; i < items_number; i++) {
							this_item = Drupal.settings.yandex_map.items[i];
							// prepare & build placemark
							placemark_gp = new YMaps.GeoPoint(this_item.lng,
									this_item.lat);
							placemark = new YMaps.Placemark(placemark_gp);
							placemark.setIconContent(null);
							placemark.setOptions(placemark_options);
							placemark.setBalloonOptions(balloon_options);
							placemark.setBalloonContent('<b>' + this_item.title
									+ '</b><br />' + this_item.description);
							placemarks[i] = placemark;
							map.addOverlay(placemarks[i]);
							collectionBounds.add( [ placemark_gp ]);
						}
						if (items_number > 1) {
							map.setBounds(collectionBounds);
						} else {
							// set map center
							map.setCenter(new YMaps.GeoPoint(
									Drupal.settings.yandex_map.center.lng,
									Drupal.settings.yandex_map.center.lat),
									Drupal.settings.yandex_map.center.zoom);
							if ((this_item.title || this_item.description)
									&& Drupal.settings.yandex_map.ballon_on_view
									&& items_number == 1)
								placemark.openBalloon();
						}

					}
					// [end] this is not "add" or "edit" page
				});
		} else { // no placemark
			YMaps.jQuery(function() {
				// Создает экземпляр карты и привязывает его к созданному
				// контейнеру
					var map = new YMaps.Map(YMaps.jQuery("#yandex_map_view")[0]);
					if (Drupal.settings.yandex_map.default_place.city) {
						var geocoder = new YMaps.Geocoder(
								Drupal.settings.yandex_map.default_place.city,
								{
									results : 1
								});
						YMaps.Events.observe(geocoder, geocoder.Events.Load,
								function() {
									if (this.length()) {
										placemarks = this.get(0);
										// map.setCenter(placemarks.getGeoPoint(),Drupal.settings.yandex_map.default_place.zoom);
								map.setCenter(placemarks.getGeoPoint(), 10);
							}
						});
					} else {
						map.setCenter(new YMaps.GeoPoint(25.33, 50.75), 13);
						alert("Enter the default city to show on Yandex Map setting forms!");
					}
					mapCommonSet(map);
				});
		}
	} else {
		$('#yandex_map').css( {
			"display" : "none"
		});
	}
};